<?

 /*************************************************************************************
 * Filename: modules/feedback.php
 *
 * This file is part of the Login JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Login JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/contact/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_contact_feedback extends Module
 {
  function __construct(&$data)
  {
   global $_config;

   parent::__construct($data);

   $this->data->title="Contact feedback";

   $this->data->defaultFields("id;rights;added;updated");
   $this->data->addField("user", "nr", "all", "", 1, false, "usernr", "User");
   $this->data->addReference("user", $_config->get("usermodule"), "nr", "*:1");

   $this->data->addField("name", "text", "all", "", 0, 255, false, "Name");
   $this->data->addField("email", "email", "all", "", 0, 255, false, "Email address");
   
   $this->data->addField("topic", "list", "all", "title", 0, 255, false, "Topic");
   $this->data->addField("subject", "text", "all", "title", 0, 255, false, "Subject");
   $this->data->addField("message", "text", "all", "markup", 0, 65536, false, "Message");

   $this->data->addField("workflow", "nr", "all", "", 1, false, "Feedback", "Workflow");
   $this->data->addReference("workflow", "workflow", "nr", "*:1");


   $this->data->addFullTextIndex("fulltext", "name", "email", "topic", "subject", "message");

   $this->data->group("Details", "name", "email");
   $this->data->group("Feedback", "topic", "subject", "message");
   $this->data->group("Workflow", "workflow");

   $this->data->sortOrder("workflow", "added-", "subject");
  }


  function postInit(){if($this->data->action=="add"){return $this->customizeFields();} return true;}
  function copyPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   if(!$this->data->getReferenceData("workflow")->moduleObject->determineState($this->data))
    return false;

   return true;
  }


  function addPreSubmitErrorCheck(){return $this->checkValues();}
  function copyPreSubmitErrorCheck(){return $this->checkValues();}
  function editPreSubmitErrorCheck(){return $this->checkValues();}

  function checkValues()
  {
   if($this->data->check("valuetype", "default", "catnr"))
    $this->data->setValue("catnr", $this->data->getValue("catnr"));

   if($this->data->check("valuetype", "default", "workflow"))
    $this->data->setValue("workflow", array_keys($this->data->listOptions["workflow"])[0]);

   if(!$this->data->getReferenceData("workflow")->moduleObject->validateState($this->data))
    return false;

   return true;
  }


 }
?>
