<?

 /*************************************************************************************
 * Filename: modules/pluginConfigs.php
 *
 * This file is part of the Login JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Login JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/contact/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_contact_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   global $_path, $_config;

   parent::__construct($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="Contact plugin configuration";

   $this->data->addField("title", "text", "all", "", 0, 255, "Contact", "Title");
   $this->data->addField("text", "html", "all", "wysiwyg", 0, 65535, "Please fill in the form beflow", "Text");

   $this->data->addField("fields", "multilist", "all", "reload", 0, 255, Array("name", "subject", "message"), "Feedback form fields");
   $this->data->addField("required", "multilist", "all", "", 0, 255, Array("name", "subject", "message"), "Required fields");

   $this->data->addField("restrictSubmits", "boolean", "all", "reload", false, false, true, "Restrict submits");
   $this->data->addField("useCaptcha", "boolean", "all", "reload", false, false, true, "Use Captcha");
   $this->data->addField("httpsRedirect", "boolean", "all", false, false, false, true, "Secure form (HTTPS)");

   $this->data->addField("topics", "text", "all", "", 0, 255, "", "Topics", "Comma separated list of topics");
   $this->data->addField("success", "text", "all", "markup", 5, 255, "[b]Thank you for your feedback[b]", "Success message");
   $this->data->addField("email", "email", "all", "", 0, 255, "", "Forward feedback to email address");

   $this->data->addField("feedbackcatnr", "nr", "all", "", false, false, false, "Feedback category");
   $this->data->addReference("feedbackcatnr", "categories", "nr", "*:0");

   $this->data->group("Feedback", "fields", "required", "restrictSubmits", "useCaptcha", "httpsRedirect", "topics", "success", "email", "feedbackcatnr");
  }

  function postInit(){return $this->customizeFields();}
  function viewPostGet(){return $this->customizeFields();}
  function copyPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   //get fields list options
   $fields=Array();
   $d=Data::cache("contact_feedback", "view", "item");
   foreach($d->check("use", "form") as $field)
    if(!$d->check("properties", "default", $field)&&!$d->check("properties", "control", $field))
     if($field!="workflow")
      $fields[$field]=$d->title($field);

   $this->data->listOptions("fields", $fields);

   if($values=$this->data->getValue("fields"))
   {
    $required=Array();
    foreach($fields as $field => $title)
     if(in_array($field, $values))
      $required[$field]=$d->title($field);

    $this->data->resetField("required");
    $this->data->listOptions("required", $required);
    
    $this->data->resetField("restrictSubmits");
    $this->data->resetField("useCaptcha");
    $this->data->resetField("httpsRedirect");

    if(in_array("topic", $values))
     $this->data->resetField("topics");
    else
     $this->data->field["topics"]["properties"].=";hidden";

    if($this->data->getValue("restrictSubmits"))
    {
     $this->data->setValue("useCaptcha", false);
     $this->data->field["useCaptcha"]["properties"].=";hidden";
    }
    else
    {
     $this->data->resetField("useCaptcha");

     if($this->data->getValue("useCaptcha"))
     {
      $this->data->setValue("restrictSubmits", false);
      $this->data->field["restrictSubmits"]["properties"].=";hidden";
     }
     else
      $this->data->resetField("restrictSubmits");
    }

    $this->data->resetField("success");
    $this->data->resetField("feedbackcatnr");
   }
   else
   {
    $this->data->field["required"]["properties"].=";hidden";
    $this->data->field["restrictSubmits"]["properties"].=";hidden";
    $this->data->field["useCaptcha"]["properties"].=";hidden";
    $this->data->field["httpsRedirect"]["properties"].=";hidden";
    $this->data->field["topics"]["properties"].=";hidden";
    $this->data->field["feedbackcatnr"]["properties"].=";hidden";
    $this->data->field["success"]["properties"].=";hidden";
   }

   return true;
  }

 }
?>
